#!/usr/bin/perl
use Socket;
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){read (STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.="#$value";}
		else {$data{$field}=$value;}
	}
}
$encline="$data{name}:".crypt($data{password},$data{password});
$destination=$data{method};
$destination="genset" unless ($destination);

$admpass="$alogin:$apassword";
&$destination if ($admpass eq $encline);
open (F,"<$mwpath/template/aerrauth.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;

sub genset
{
$selected{genset}="selected";
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT subj,mstyle,header,footer,aheader,afooter,uheader,ufooter FROM mw_settings");
($subject,$type,$mlheader,$mlfooter,$raheader,$rafooter,$ruheader,$rufooter)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$subject=~s/APOSTROPHH/'/g;
$mlheader=~s/APOSTROPHH/'/g;
$mlfooter=~s/APOSTROPHH/'/g;
$raheader=~s/APOSTROPHH/'/g;
$rafooter=~s/APOSTROPHH/'/g;
$ruheader=~s/APOSTROPHH/'/g;
$rufooter=~s/APOSTROPHH/'/g;
if ($type==0){$result=qq~<table width="100%"><tr><td><font size=2>PLAIN TEXT</font></td><td><input type="radio" name="type" value="0" checked></td></tr><tr><td><font size=2>HTML</font></td><td><input type="radio" name="type" value="1"></td></tr></table>~;}
else {$result=qq~<table width="100%"><tr><td><font size=2>PLAIN TEXT</font></td><td><input type="radio" name="type" value="0"></td></tr><tr><td><font size=2>HTML</font></td><td><input type="radio" name="type" value="1" checked></td></tr></table>~;}
&methods;
&closedb;
open (F,"<$mwpath/template/agenset.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub chmlset
{
$data{subject}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES mw_settings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_settings SET subj='$data{subject}',mstyle=$data{type}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub chpass
{
$data{name}=$data{login};
$data{password}=$data{pass};
$apassword=crypt($data{password},$data{password});
open(F,">mworld.cfg");
print F qq~#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$mwpath="$mwpath";
\$backuppath="$backuppath";
\$cgi="$cgi";
\$mailworld="$mailworld";
\$sysid="$sysid";
\$progmail="$progmail";
\$email='$email';
\$furl="$furl";
\$owntitle="$owntitle";
\$license="$license";
\$bcc=$bcc;
\$smtpserver="$smtpserver";
\$smtpport=$smtpport;
\$alogin='$data{name}';
\$apassword='$apassword';
\$mysqlhost="$mysqlhost";
\$mysqldb="$mysqldb";
\$mysqllogin="$mysqllogin";
\$mysqlpassword="$mysqlpassword";
\$locktables=$locktables;
\$LOCK_SH=1;
\$LOCK_EX=2;
\$LOCK_NB=4;
\$LOCK_UN=8;
\%cal=('Jan','1','Feb','2','Mar','3','Apr','4','May','5','Jun','6','Jul','7','Aug','8','Sep','9','Oct','10','Nov','11','Dec','12');
~;
close(F);
&genset;
}
sub ruheader
{
$data{header}=~s/'/APOSTROPHH/g;
$data{footer}=~s/'/APOSTROPHH/g;
$data{header}=~s/\r//g;
$data{footer}=~s/\r//g;
$sth=$dbh->query("LOCK TABLES mw_settings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_settings SET uheader='$data{header}',ufooter='$data{footer}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub raheader
{
$data{header}=~s/'/APOSTROPHH/g;
$data{footer}=~s/'/APOSTROPHH/g;
$data{header}=~s/\r//g;
$data{footer}=~s/\r//g;
$sth=$dbh->query("LOCK TABLES mw_settings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_settings SET aheader='$data{header}',afooter='$data{footer}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub mlheader
{
$data{header}=~s/'/APOSTROPHH/g;
$data{footer}=~s/'/APOSTROPHH/g;
$data{header}=~s/\r//g;
$data{footer}=~s/\r//g;
$sth=$dbh->query("LOCK TABLES mw_settings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_settings SET header='$data{header}',footer='$data{footer}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub chset
{
open(F,">mworld.cfg");
print F qq~#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$mwpath="$data{mwpath}";
\$backuppath="$data{backuppath}";
\$cgi="$data{cgi}";
\$mailworld="$data{mailworld}";
\$sysid="$data{sysid}";
\$progmail="$data{progmail}";
\$email='$data{email}';
\$furl="$data{furl}";
\$owntitle="$data{owntitle}";
\$license="$license";
\$bcc=$data{bcc};
\$smtpserver="$data{smtpserver}";
\$smtpport=$data{smtpport};
\$alogin='$alogin';
\$apassword='$apassword';
\$mysqlhost="$data{mysqlhost}";
\$mysqldb="$data{mysqldb}";
\$mysqllogin="$data{mysqllogin}";
\$mysqlpassword="$data{mysqlpassword}";
\$locktables=$data{locktables};
\$LOCK_SH=1;
\$LOCK_EX=2;
\$LOCK_NB=4;
\$LOCK_UN=8;
\%cal=('Jan','1','Feb','2','Mar','3','Apr','4','May','5','Jun','6','Jul','7','Aug','8','Sep','9','Oct','10','Nov','11','Dec','12');
~;
close(F);
open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
&genset
}
sub acctypes
{
$selected{acctypes}="selected";
$data{type}=1 unless ($data{type});
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT atid,atname,allowsend,maxsubscr,maxlist,autoaccept,allowsends,validation,limitpermonth,advert,archive,addfeat,usedomain,advertad FROM mw_acctype");
while (($atid,$atname,$var1,$var2,$var3,$var4,$var5,$var6,$var7,$var8,$var9,$var10,$var11,$var12)=$sth->fetchrow)
{
	$atname=~s/APOSTROPHH/'/g;
	$toedit.=qq~<option value="$atid">$atname</option>\n~;
	if ($atid!=1)
	{
		$toremove.=qq~<option value="$atid">$atname</option>\n~;
	}
	if ($data{type}==$atid)
	{
		$allowsend=$var1;
		$maxsubscr=$var2;
		$maxlist=$var3;
		$autoaccept=$var4;
		$allowsends=$var5;
		$validation=$var6;
		$limitpermonth=$var7;
		$advert=$var8;
		$archive=$var9;
		$addfeat=$var10;
		$usedomain=$var11;
		$advertad=$var12;
		$allowsend[$allowsend]="selected";
		$autoaccept[$autoaccept]="selected";
		$allowsends[$allowsends]="selected";
		$validation[$validation]="selected";
		$advert[$advert]="selected";
		$archive[$archive]="selected";
		$addfeat[$addfeat]="selected";
		$usedomain[$usedomain]="selected";
		$curname=$atname;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$advertad=~s/APOSTROPHH/'/g;
&methods;
&closedb;
open (F,"<$mwpath/template/aacctype.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub addtype
{
$data{advertad}=~s/'/APOSTROPHH/g;
$data{advertad}=~s/\r//g;
$data{atname}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES mw_acctype WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO mw_acctype (atname,allowsend,maxsubscr,maxlist,autoaccept,allowsends,validation,limitpermonth,advert,archive,addfeat,usedomain,advertad) VALUES ('$data{atname}',$data{allowsend},$data{maxsubscr},$data{maxlist},$data{autoaccept},$data{allowsends},$data{validation},$data{limitpermonth},$data{advert},$data{archive},$data{addfeat},$data{usedomain},'$data{advertad}')");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&acctypes;
}
sub remtype
{
$selected{acctypes}="selected";
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_users WHERE acctype=$data{toremove}");
$accounts=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&methods;
&closedb;
open (F,"<$mwpath/template/aremtype.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remtype_c
{
$sth=$dbh->query("LOCK TABLES mw_users WRITE,mw_lists WRITE,mw_acctype WRITE,mw_alist WRITE") if ($locktables);
$sth=$dbh->query("SELECT uid FROM mw_users WHERE acctype=$data{toremove}");
while ($uid=$sth->fetchrow)
{
	$sthx=$dbh->query("DROP TABLE mw_subscr_$uid");
	$sthx=$dbh->query("DROP TABLE mw_history_$uid");
	$sthx=$dbh->query("DELETE FROM mw_lists WHERE uid=$uid");
	$sthx="";
}
$sth=$dbh->query("DELETE FROM mw_alist WHERE email=ANY (SELECT email FROM mw_users WHERE acctype=$data{toremove})");
$sth=$dbh->query("DELETE FROM mw_users WHERE acctype=$data{toremove}");
$sth=$dbh->query("DELETE FROM mw_acctype WHERE atid=$data{toremove}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&acctypes;
}
sub edittype
{
$data{advertad}=~s/'/APOSTROPHH/g;
$data{advertad}=~s/\r//g;
$data{atname}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES mw_acctype WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_acctype SET atname='$data{atname}',allowsend=$data{allowsend},maxsubscr=$data{maxsubscr},maxlist=$data{maxlist},autoaccept=$data{autoaccept},allowsends=$data{allowsends},validation=$data{validation},limitpermonth=$data{limitpermonth},advert=$data{advert},archive=$data{archive},addfeat=$data{addfeat},usedomain=$data{usedomain},advertad='$data{advertad}' WHERE atid=$data{type}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&acctypes;
}
sub userman
{
$selected{userman}="selected";
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
if ($data{type})
{
	$selec[$data{type}]="selected";
	if ($data{status} ne "")
	{
		$sth=$dbh->query("SELECT uid,email FROM mw_users WHERE (acctype=$data{type} AND status=$data{status}) ORDER BY email");
		$sele[$data{status}]="selected";
	}
	else
	{
		$sth=$dbh->query("SELECT uid,email FROM mw_users WHERE acctype=$data{type} ORDER BY email");
	}
}
else
{
	if ($data{status} ne "")
	{
		$sth=$dbh->query("SELECT uid,email FROM mw_users WHERE status=$data{status} ORDER BY email");
		$sele[$data{status}]="selected";
	}
	else
	{
		$sth=$dbh->query("SELECT uid,email FROM mw_users ORDER BY email");
	}
}
while (($uid,$uemail)=$sth->fetchrow)
{
	$userz.=qq~<option value="$uid">$uemail</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT atid,atname FROM mw_acctype");
while (($atid,$atname)=$sth->fetchrow)
{
	$atname=~s/APOSTROPHH/'/g;
	$types.=qq~<option value="$atid" $selec[$atid]>$atname</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&methods;
&closedb;
open (F,"<$mwpath/template/ausrman.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub removeusr
{
&methods;
&closedb;
open (F,"<$mwpath/template/aremuser.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub removeusr_c
{
@users=split("#",$data{user});
$sth=$dbh->query("LOCK TABLES mw_users WRITE,mw_lists WRITE,mw_alist WRITE") if ($locktables);
foreach(@users)
{
	$sth=$dbh->query("DELETE FROM mw_alist WHERE email=ANY (SELECT email FROM mw_users WHERE uid=$_)");
	$sth=$dbh->query("DELETE FROM mw_users WHERE uid=$_");
	$sth=$dbh->query("DELETE FROM mw_lists WHERE uid=$_");
	$sth=$dbh->query("DROP TABLE mw_history_$_");
	$sth=$dbh->query("DROP TABLE mw_subscr_$_");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&userman;
}
sub disable_acc
{
@usrs=split("#",$data{user});
$sth=$dbh->query("LOCK TABLES mw_users WRITE") if ($locktables);
foreach(@usrs)
{
	if ($_)
	{
		$sth=$dbh->query("UPDATE mw_users SET status=2 WHERE uid=$_");
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&userman;
}
sub enable_acc
{
@usrs=split("#",$data{user});
$sth=$dbh->query("LOCK TABLES mw_users WRITE") if ($locktables);
foreach(@usrs)
{
	if ($_)
	{
		$sth=$dbh->query("UPDATE mw_users SET status=1 WHERE uid=$_");
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&userman;
}
sub chtype
{
@usrs=split("#",$data{user});
$sth=$dbh->query("LOCK TABLES mw_users WRITE") if ($locktables);
foreach(@usrs)
{
	if ($_)
	{
		$sth=$dbh->query("UPDATE mw_users SET acctype=$data{typ} WHERE uid=$_");
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&userman;
}
sub userlist
{
$selected{userman}="selected";
$start=$data{start};
@data=();
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
if ($data{type})
{
	if ($data{status} ne "")
	{
		$sth=$dbh->query("SELECT uid,email,acctype,status FROM mw_users WHERE (acctype=$data{type} AND status=$data{status}) ORDER BY email");
	}
	else
	{
		$sth=$dbh->query("SELECT uid,email,acctype,status FROM mw_users WHERE acctype=$data{type} ORDER BY email");
	}
}
else
{
	if ($data{status} ne "")
	{
		$sth=$dbh->query("SELECT uid,email,acctype,status FROM mw_users WHERE status=$data{status} ORDER BY email");
	}
	else
	{
		$sth=$dbh->query("SELECT uid,email,acctype,status FROM mw_users ORDER BY email");
	}
}
while (($uid,$uemail,$acctype,$status)=$sth->fetchrow)
{
	push(@data,"$uid\t$uemail\t$acctype\t$status");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT atid,atname FROM mw_acctype");
while (($atid,$atname)=$sth->fetchrow)
{
	$atname=~s/APOSTROPHH/'/g;
	$acctypes[$atid]=$atname;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$status[0]="Not approved";
$status[1]="Enabled";
$status[2]="Disabled";
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>20)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=$data{method}&start=$pstart&type=$data{type}&status=$data{status}\">PREV</a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=1><b>$icount MEMBERS IN DATABASE</b></font></td>");
	if ($start*20+20<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=$data{method}&start=$nstart&type=$data{type}&status=$data{status}\">NEXT</a></td>");
	}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=1><b>$icount MEMBERS IN DATABASE</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*20+20>scalar(@data))
{
	$i=$start*20;
	while($i<scalar(@data))
	{
		($uid,$user,$type,$status)=split("\t",$data[$i]);
		$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_lists WHERE uid=$uid");
		$lists=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$uid");
		$subs=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		push(@result,"<li><font size=2><b>Member email:</b> <a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=userinfo&user=$uid\">$user</a><br><b>Account type:</b> $acctypes[$type]<br><b>Account status:</b> $status[$status]<br><b>Total lists:</b> $lists<br><b>Total subscribers:</b> $subs</font></li>\n");
		$i++;
	}
}
else
{
	$i=$start*20;
	$last=$i+20;
	while($i<$last)
	{
		($uid,$user,$type,$status)=split("\t",$data[$i]);
		$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_lists WHERE uid=$uid");
		$lists=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$uid");
		$subs=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		push(@result,"<li><font size=2><b>Member email:</b> <a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=userinfo&user=$uid\">$user</a><br><b>Account type:</b> $acctypes[$type]<br><b>Account status:</b> $status[$status]<br><b>Total lists:</b> $lists<br><b>Total subscribers:</b> $subs</font></li>\n");
		$i++;
	}
}
if (!@result)
{
	push(@result,"<li>No members</li>");
}
&methods;
&closedb;
open (F,"<$mwpath/template/ausrlist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub userinfo
{
$selected{userman}="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname FROM mw_lists WHERE uid=$data{user}");
while(($lid,$lname)=$sth->fetchrow)
{
	$sthx=$dbh->query("LOCK TABLES mw_subscr_$data{user} READ") if ($locktables);
	$sthx=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$data{user} WHERE lid=$lid");
	$total=$sthx->fetchrow;
	$sthx=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sthx="";
	$result.=qq~<tr><td><font size="2">$lname</font></td><td><font size="2">$total</font></td><td><font size="2"><form action="$cgi/mwadmin.pl" method=post><input type=hidden name=name value=$data{name}><input type=hidden name=password value=$data{password}><input type=hidden name=method value=download><input type=hidden name=user value=$data{user}><input type=hidden name=list value=$lid><input type=submit value=Get></form></font></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&methods;
&closedb;
open (F,"<$mwpath/template/ausrinfo.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub download
{
if ($data{user})
{
	if ($data{list})
	{
		$sth=$dbh->query("LOCK TABLES mw_subscr_$data{user} READ") if ($locktables);
		$sth=$dbh->query("SELECT email FROM mw_subscr_$data{user} WHERE (lid=$data{list} AND status=1)");
		@list=$sth->fetchcol;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
	else
	{
		$sth=$dbh->query("LOCK TABLES mw_subscr_$data{user} READ") if ($locktables);
		$sth=$dbh->query("SELECT DISTINCT email FROM mw_subscr_$data{user} WHERE status=1");
		@list=$sth->fetchcol;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
}
else
{
	$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
	if ($data{type})
	{
		$selec[$data{type}]="selected";
		if ($data{status} ne "")
		{
			$sth=$dbh->query("SELECT uid FROM mw_users WHERE (acctype=$data{type} AND status=$data{status}) ORDER BY email");
			$sele[$data{status}]="selected";
		}
		else
		{
			$sth=$dbh->query("SELECT uid FROM mw_users WHERE acctype=$data{type} ORDER BY email");
		}
	}
	else
	{
		if ($data{status} ne "")
		{
			$sth=$dbh->query("SELECT uid FROM mw_users WHERE status=$data{status} ORDER BY email");
			$sele[$data{status}]="selected";
		}
		else
		{
			$sth=$dbh->query("SELECT uid FROM mw_users ORDER BY email");
		}
	}
	@users=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach(@users)
	{
		$sth=$dbh->query("LOCK TABLES mw_subscr_$_ READ") if ($locktables);
		$sth=$dbh->query("SELECT DISTINCT email FROM mw_subscr_$_ WHERE status=1");
		@mlist=$sth->fetchcol;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		foreach(@mlist){$list.="$_#" unless ($list=~/$_#/);}
	}
	chop($list);
	@list=split("#",$list);
}
&closedb;
foreach(@list){$_.="\n";}
print "content-disposition: filename=\"list.txt\"; \n";
print "content-type: application/msword\n\n";
print @list;
exit;
}
sub newacc
{
$selected{newacc}="selected";
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,email FROM mw_users WHERE status=0 ORDER BY email");
while (($uid,$uemail)=$sth->fetchrow)
{
	$userz.=qq~<option value="$uid">$uemail</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&methods;
&closedb;
open (F,"<$mwpath/template/anewacc.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub accept_acc
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES mw_users WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_users SET status=1 WHERE uid=$data{user}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT uheader,ufooter FROM mw_settings");
($header,$bottom)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM mw_users WHERE uid=$data{user}");
$data{user}=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$header=~s/APOSTROPHH/'/g;
$bottom=~s/APOSTROPHH/'/g;
if ($smtpserver)
{
	&sendviasmtp("$email ($owntitle)",$data{user},"Welcome to MailWorld - Your account accepted","$header\nCongratulations! Your account has been accepted. You can login to manage your account at:\n\n$mailworld/members.html\n\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $data{user}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Welcome to MailWorld - Your account accepted\n\n";
print MAIL $header;
print MAIL "Congratulations! Your account has been accepted. You can login to manage your account at:\n\n";
print MAIL "$mailworld/members.html\n\n";
print MAIL $bottom;
print MAIL "\n.\n";
close (MAIL);
}
}
&newacc;
}
sub decline_acc
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES mw_users WRITE,mw_lists WRITE,mw_alist WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM mw_alist WHERE email=ANY (SELECT email FROM mw_users WHERE uid=$data{user})");
$sth=$dbh->query("SELECT email FROM mw_users WHERE uid=$data{user}");
$data{usere}=$sth->fetchrow;
$sth=$dbh->query("DELETE FROM mw_users WHERE uid=$data{user}");
$sth=$dbh->query("DELETE FROM mw_lists WHERE uid=$data{user}");
$sth=$dbh->query("DROP TABLE mw_history_$data{user}");
$sth=$dbh->query("DROP TABLE mw_subscr_$data{user}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT uheader,ufooter FROM mw_settings");
($header,$bottom)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$header=~s/APOSTROPHH/'/g;
$bottom=~s/APOSTROPHH/'/g;
$data{user}=$data{usere};
if ($smtpserver)
{
	$header=join("",@header);
	$bottom=join("",@footer);
	&sendviasmtp("$email ($owntitle)",$data{user},"Sorry - Your account has been removed","$header\nYour account has been removed. Reason: $data{reason}\n\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $data{user}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Sorry - Your account has been removed\n\n";
print MAIL $header;
print MAIL "Your account has been removed. Reason: $data{reason}\n\n";
print MAIL $bottom;
print MAIL "\n.\n";
close (MAIL);
}
}
&newacc;
}
sub alistman
{
$selected{alistman}="selected";
$sth=$dbh->query("LOCK TABLES mw_alist READ") if ($locktables);
$sth=$dbh->query("SELECT sid,email FROM mw_alist ORDER BY email");
while (($sid,$uemail)=$sth->fetchrow)
{
	$users.=qq~<option value="$sid">$uemail</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&methods;
&closedb;
open (F,"<$mwpath/template/amlman.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub removeaddr
{
@users=split("#",$data{user});
$sth=$dbh->query("LOCK TABLES mw_alist WRITE") if ($locktables);
foreach(@users)
{
	$sth=$dbh->query("DELETE FROM mw_alist WHERE sid=$_");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&alistman;
}
sub addemail
{
$data{adduser}=~s/ //g;
$data{adduser}=~s/\r//g;
$data{adduser}=~s/,/\n/g;
@usrs=split("\n",$data{adduser});
$sth=$dbh->query("LOCK TABLES mw_alist WRITE") if ($locktables);
foreach(@usrs)
{
	if ($_ && $_=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $_=~/^\w+/ && $_=~/\w+$/)
	{
		$sth=$dbh->query("INSERT INTO mw_alist (email) VALUES ('$_')");
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&alistman;
}
sub sendml
{
$selected{sendml}="selected";
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_users");
$totals=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_alist READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_alist");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT mstyle,subj FROM mw_settings");
($type,$subject)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$subject=~s/APOSTROPHH/'/g;
&methods;
&closedb;
open (F,"<$mwpath/template/asendml.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub maillist
{
$selected{sendml}="selected";
if ($data{type} eq "S")
{
$sth=$dbh->query("LOCK TABLES mw_alist READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_alist");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($data{type} eq "M")
{
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_users");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT header,footer FROM mw_settings");
($header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$data{body}=~s/'/APOSTROPHH/g;
$data{body}=~s/\r//g;
$data{subject}=~s/'/APOSTROPHH/g;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$sth=$dbh->query("LOCK TABLES mw_ahistory WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO mw_ahistory (statd,subject,message) VALUES ('$year-$month-$date $time','$data{subject}','$header\n$data{body}\n\n$footer')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$hid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$addres=qq~<script type="text/javascript" language="Javascript">
window.open("$cgi/nph-mwamail.pl?method=maillist&type=$data{type}&name=$data{name}&password=$data{password}&hid=$hid", 'f', 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=113,height=135');
</script>
~;
&methods;
&closedb;
open (F,"<$mwpath/template/asendmail.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub help
{
$selected{help}="selected";
&methods;
&closedb;
open (F,"<$mwpath/template/ahelp.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub mailuser
{
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT header,footer FROM mw_settings");
($header,$bottom)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM mw_users WHERE uid=$data{user}");
$data{usere}=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$header=~s/APOSTROPHH/'/g;
$bottom=~s/APOSTROPHH/'/g;
if ($smtpserver)
{
	&sendviasmtp("$email ($owntitle)",$data{usere},"$data{subject}","$header\n$data{body}\n\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $data{usere}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: $data{subject}\n\n";
print MAIL $header;
print MAIL "$data{body}\n\n";
print MAIL $bottom;
print MAIL "\n.\n";
close (MAIL);
}
&userinfo;
}
sub messhist
{
$selected{messhist}="selected";
$start=$data{start};
@data=();
$sth=$dbh->query("LOCK TABLES mw_ahistory READ") if ($locktables);
$sth=$dbh->query("SELECT hid,statd,subject FROM mw_ahistory ORDER BY statd DESC");
while (($hid,$statd,$subject)=$sth->fetchrow)
{
	$subject=~s/APOSTROPHH/'/g;
	push(@data,"$hid\t$subject\t$statd");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>20)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=$data{method}&start=$pstart\">PREV</a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=1><b>$icount MESSAGES IN ARCHIVE</b></font></td>");
	if ($start*20+20<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=$data{method}&start=$nstart\">NEXT</a></td>");
	}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=1><b>$icount MESSAGES IN ARCHIVE</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*20+20>scalar(@data))
{
	$i=$start*20;
	while($i<scalar(@data))
	{
		($hid,$subject,$statd)=split("\t",$data[$i]);
		push(@result,"<tr><td><font size=2>$statd</font></td><td><font size=2><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=readmessage&hid=$hid\">$subject</a></td></tr>\n");
		$i++;
	}
}
else
{
	$i=$start*20;
	$last=$i+20;
	while($i<$last)
	{
		($hid,$subject,$statd)=split("\t",$data[$i]);
		push(@result,"<tr><td><font size=2>$statd</font><td><td><font size=2><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=readmessage&hid=$hid\">$subject</a></td></tr>\n");
		$i++;
	}
}
if (!@result)
{
	push(@result,"<tr><td colspan=2 align=center><font size=2>No messages in archive</font></td></tr>");
}
&methods;
&closedb;
open (F,"<$mwpath/template/amesshist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub readmessage
{
$selected{messhist}="selected";
$sth=$dbh->query("LOCK TABLES mw_ahistory READ") if ($locktables);
$sth=$dbh->query("SELECT subject,message FROM mw_ahistory WHERE hid=$data{hid}");
($subject,$message)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$subject=~s/APOSTROPHH/'/g;
$message=~s/APOSTROPHH/'/g;
$message=~s/\n/\<br\>\n/g;
&methods;
&closedb;
open (F,"<$mwpath/template/amessage.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub systools
{
$selected{systools}="selected";
$status.="Backup system status:<br>";
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
shift(@files) if ($files[0] eq "log.db");
if (@files)
{
	($atime,$mtime)=(stat("$backuppath/$files[0]"))[8,9];
	($day,$month,$date,$time,$year)=split(" ",scalar localtime($mtime));
	$status.="Database was backed up on $date/$month/$year $time";
}
else
{
	$status.="Database wasnt backed up.";
}
&methods;
&closedb;
open (F,"<$mwpath/template/asystools.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub backup_data
{
$sth=$dbh->query("LOCK TABLES mw_users WRITE, mw_lists WRITE, mw_settings WRITE, mw_acctype WRITE, mw_alist WRITE, mw_ahistory WRITE") if ($locktables);
$sth=$dbh->query("BACKUP TABLE mw_users,mw_lists,mw_settings,mw_acctype,mw_alist,mw_ahistory TO '$backuppath'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM mw_users");
@users=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@users)
{
	$sth=$dbh->query("LOCK TABLES mw_history_$_ WRITE, mw_subscr_$_ WRITE") if ($locktables);
	$sth=$dbh->query("BACKUP TABLE mw_history_$_,mw_subscr_$_ TO '$backuppath'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&systools;
}
sub delete_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files)
{
	unlink("$backuppath/$_") if ($_ ne "log.db");
}
&systools;
}
sub install_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
shift(@files) if ($files[0] eq "log.db");
if(@files)
{
	$sth=$dbh->query("LOCK TABLES mw_users WRITE, mw_lists WRITE, mw_settings WRITE, mw_acctype WRITE, mw_alist WRITE, mw_ahistory WRITE") if ($locktables);
	$sth=$dbh->query("DROP TABLE mw_users,mw_lists,mw_settings,mw_acctype,mw_alist,mw_ahistory");
	$sth=$dbh->query("RESTORE TABLE mw_users,mw_lists,mw_settings,mw_acctype,mw_alist,mw_ahistory FROM '$backuppath'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT uid FROM mw_users");
	@users=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach(@users)
	{
		$sth=$dbh->query("LOCK TABLES mw_history_$_ WRITE, mw_subscr_$_ WRITE") if ($locktables);
		$sth=$dbh->query("DROP TABLE mw_history_$_,mw_subscr_$_");
		$sth=$dbh->query("RESTORE TABLE mw_history_$_,mw_subscr_$_ FROM '$backuppath'");
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
}
&systools;
}
sub sql_dump
{
$file="CREATE TABLE mw_users (uid MEDIUMINT(6) UNSIGNED NOT NULL auto_increment,email VARCHAR(255) NOT NULL,password VARCHAR(8) NOT NULL,name VARCHAR(150) NOT NULL,acctype MEDIUMINT(3) NOT NULL,status TINYINT(1),lastdate DATETIME,lastsip VARCHAR(15),lastuip VARCHAR(15),PRIMARY KEY (uid),INDEX (uid,email,acctype,status));\n";
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM mw_users");
while (($uid,$email,$password,$name,$acctype,$status,$lastdate,$lastsip,$lastuip)=$sth->fetchrow)
{
	push(@uids,$uid);
	$file.="INSERT INTO mw_users (uid,email,password,name,acctype,status,lastdate,lastsip,lastuip) VALUES ($uid,'$email','$password','$name',$acctype,$status,'$lastdate','$lastsip','$lastuip');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE mw_lists (lid MEDIUMINT(8) UNSIGNED NOT NULL auto_increment,uid MEDIUMINT(6) UNSIGNED NOT NULL,lname VARCHAR(100),subj VARCHAR(255),mstyle TINYINT(1),header TEXT,footer TEXT,PRIMARY KEY (lid),INDEX (lid,uid));\n";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM mw_lists");
while (($lid,$uid,$lname,$subj,$mstyle,$header,$footer)=$sth->fetchrow)
{
	$file.="INSERT INTO mw_lists (lid,uid,lname,subj,mstyle,header,footer) VALUES ($lid,$uid,'$lname','$subj',$mstyle,'$header','$footer');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE mw_acctype (atid MEDIUMINT(3) UNSIGNED NOT NULL auto_increment,atname VARCHAR(30) NOT NULL,allowsend TINYINT(1),maxsubscr MEDIUMINT(6),maxlist MEDIUMINT(3),autoaccept TINYINT(1),allowsends TINYINT(1),validation TINYINT(1),limitpermonth MEDIUMINT(3),advert TINYINT(1),archive TINYINT(1),addfeat TINYINT(1),usedomain TINYINT(1),advertad TEXT,PRIMARY KEY (atid),INDEX (atid));\n";
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM mw_acctype");
while (($atid,$atname,$allowsend,$maxsubscr,$maxlist,$autoaccept,$allowsends,$validation,$limitpermonth,$advert,$archive,$addfeat,$usedomain,$advertad)=$sth->fetchrow)
{
	$file.="INSERT INTO mw_acctype (atid,atname,allowsend,maxsubscr,maxlist,autoaccept,allowsends,validation,limitpermonth,advert,archive,addfeat,usedomain,advertad) VALUES ($atid,'$atname',$allowsend,$maxsubscr,$maxlist,$autoaccept,$allowsends,$validation,$limitpermonth,$advert,$archive,$addfeat,$usedomain,'$advertad');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE mw_settings (subj VARCHAR(255),mstyle TINYINT(1),header TEXT,footer TEXT,aheader TEXT,afooter TEXT,uheader TEXT,ufooter TEXT);\n";
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM mw_settings");
while (($subj,$mstyle,$header,$footer,$aheader,$afooter,$uheader,$ufooter)=$sth->fetchrow)
{
	$file.="INSERT INTO mw_settings (subj,mstyle,header,footer,aheader,afooter,uheader,ufooter) VALUES ('$subj',$mstyle,'$header','$footer','$aheader','$afooter','$uheader','$ufooter');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE mw_alist (sid MEDIUMINT(8) UNSIGNED NOT NULL auto_increment,email VARCHAR(255),PRIMARY KEY (sid),INDEX (email));\n";
$sth=$dbh->query("LOCK TABLES mw_alist READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM mw_alist");
while (($sid,$email)=$sth->fetchrow)
{
	$file.="INSERT INTO mw_alist (sid,email) VALUES ($sid,'$email');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE mw_ahistory (hid BIGINT(11) UNSIGNED NOT NULL auto_increment,statd DATETIME NOT NULL,subject VARCHAR(255),message TEXT,PRIMARY KEY (hid),INDEX (statd));\n";
$sth=$dbh->query("LOCK TABLES mw_ahistory READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM mw_ahistory");
while (($hid,$statd,$subject,$message)=$sth->fetchrow)
{
	$file.="INSERT INTO mw_ahistory (hid,statd,subject,message) VALUES ($hid,'$statd','$subject','$message');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@uids)
{
	$file.="CREATE TABLE mw_subscr_$_ (sid MEDIUMINT(8) UNSIGNED NOT NULL auto_increment,lid MEDIUMINT(8) UNSIGNED NOT NULL,email VARCHAR(255),status TINYINT(1),PRIMARY KEY (sid),INDEX (lid,email));\n";
	$sth=$dbh->query("LOCK TABLES mw_subscr_$_ READ") if ($locktables);
	$sth=$dbh->query("SELECT * FROM mw_subscr_$_");
	while (($sid,$lid,$email,$status)=$sth->fetchrow)
	{
		$file.="INSERT INTO mw_subscr_$_ (sid,lid,email,status) VALUES ($sid,$lid,'$email',$status);\n"
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$file.="CREATE TABLE mw_history_$_ (hid BIGINT(11) UNSIGNED NOT NULL auto_increment,lid MEDIUMINT(8) UNSIGNED NOT NULL,statd DATETIME NOT NULL,subject VARCHAR(255),message TEXT,PRIMARY KEY (hid),INDEX (lid,statd));\n";
	$sth=$dbh->query("LOCK TABLES mw_history_$_ READ") if ($locktables);
	$sth=$dbh->query("SELECT * FROM mw_history_$_");
	while (($hid,$lid,$statd,$subject,$message)=$sth->fetchrow)
	{
		$file.="INSERT INTO mw_history_$_ (hid,lid,statd,subject,message) VALUES ($hid,$lid,'$statd','$subject','$message');\n"
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&closedb;
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-disposition: filename=\"mw_tables.sql\"; \n";
print "content-type: application/sqldump\n\n";
print $file;
exit;
}
sub reset_db
{
$selected{systools}="selected";
&methods;
&closedb;
open (F,"<$mwpath/template/ardb.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_db1
{
if ($data{type} eq "all")
{
	$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT uid FROM mw_users");
	@users=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach(@users)
	{
		$sth=$dbh->query("DROP TABLE mw_history_$_,mw_subscr_$_");
	}
	$sth=$dbh->query("LOCK TABLES mw_users WRITE, mw_acctype WRITE, mw_lists WRITE, mw_alist WRITE, mw_ahistory WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM mw_users");
	$sth=$dbh->query("DELETE FROM mw_acctype WHERE (atid>1)");
	$sth=$dbh->query("DELETE FROM mw_lists");
	$sth=$dbh->query("DELETE FROM mw_alist");
	$sth=$dbh->query("DELETE FROM mw_ahistory");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "history")
{
	$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT uid FROM mw_users");
	@users=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach(@users)
	{
		$sth=$dbh->query("LOCK TABLES mw_history_$_ WRITE") if ($locktables);
		$sth=$dbh->query("DELETE FROM mw_history_$_");
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
	$sth=$dbh->query("LOCK TABLES mw_ahistory WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM mw_ahistory");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&systools;
}
sub reset_stats
{
$selected{systools}="selected";
&methods;
&closedb;
open (F,"<$mwpath/template/arhist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_stats1
{
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM mw_users");
@users=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@users)
{
	$sth=$dbh->query("LOCK TABLES mw_history_$_ WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM mw_history_$_ WHERE statd<'$data{year}-$data{month}-$data{date} 00:00:00'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES mw_ahistory WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM mw_ahistory WHERE statd<'$data{year}-$data{month}-$data{date} 00:00:00'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&systools;
}
sub search
{
$selected{search}="selected";
&methods;
&closedb;
open (F,"<$mwpath/template/asearch.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub search_c
{
$selected{search}="selected";
$start=$data{start};
@data=();
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,email,acctype,status FROM mw_users WHERE email='$data{email}'");
while (($uid,$uemail,$acctype,$status)=$sth->fetchrow)
{
	push(@data,"$uid\t$uemail\t$acctype\t$status");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT atid,atname FROM mw_acctype");
while (($atid,$atname)=$sth->fetchrow)
{
	$atname=~s/APOSTROPHH/'/g;
	$acctypes[$atid]=$atname;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$status[0]="Not approved";
$status[1]="Enabled";
$status[2]="Disabled";
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>20)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=$data{method}&start=$pstart&type=$data{type}&status=$data{status}\">PREV</a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=1><b>$icount MEMBERS IN DATABASE</b></font></td>");
	if ($start*20+20<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=$data{method}&start=$nstart&type=$data{type}&status=$data{status}\">NEXT</a></td>");
	}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=1><b>$icount MEMBERS IN DATABASE</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*20+20>scalar(@data))
{
	$i=$start*20;
	while($i<scalar(@data))
	{
		($uid,$user,$type,$status)=split("\t",$data[$i]);
		$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_lists WHERE uid=$uid");
		$lists=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$uid");
		$subs=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		push(@result,"<li><font size=2><b>Member email:</b> <a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=userinfo&user=$uid\">$user</a><br><b>Account type:</b> $acctypes[$type]<br><b>Account status:</b> $status[$status]<br><b>Total lists:</b> $lists<br><b>Total subscribers:</b> $subs</font></li>\n");
		$i++;
	}
}
else
{
	$i=$start*20;
	$last=$i+20;
	while($i<$last)
	{
		($uid,$user,$type,$status)=split("\t",$data[$i]);
		$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_lists WHERE uid=$uid");
		$lists=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
		$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$uid");
		$subs=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		push(@result,"<li><font size=2><b>Member email:</b> <a href=\"$cgi/mwadmin.pl?name=$data{name}&password=$data{password}&method=userinfo&user=$uid\">$user</a><br><b>Account type:</b> $acctypes[$type]<br><b>Account status:</b> $status[$status]<br><b>Total lists:</b> $lists<br><b>Total subscribers:</b> $subs</font></li>\n");
		$i++;
	}
}
if (!@result)
{
	push(@result,"<li>Nothing found</li>");
}
&methods;
&closedb;
open (F,"<$mwpath/template/ausrlist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}


sub sendviasmtp
{
($from,$to,$subject,$message)=@_;
$message=~s/\n/\r\n/g;
$localhost=(gethostbyname('localhost'))[0] || 'localhost';
socket(S,PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]) || return;
$farg=sockaddr_in($smtpport,inet_aton($smtpserver)) || return;
connect(S,$farg) || return("err$!");
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="HELO $localhost\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="mail from: <$email>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="rcpt to: <$to>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="data\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
$mes="From:$from\r\nTo:$to\r\nSubject:$subject\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$mes="\r\n$message\r\n.\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="quit\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
close(S);
}
sub methods
{
$methods=qq~
<option value="genset" $selected{genset}>General Settings</option>
<option value="acctypes" $selected{acctypes}>Account types</option>
<option value="userman" $selected{userman}>User Management</option>
<option value="search" $selected{search}>Search</option>
<option value="newacc" $selected{newacc}>New accounts</option>
<option value="alistman" $selected{alistman}>Admin maillist management</option>
<option value="messhist" $selected{messhist}>Messages Archive</option>
<option value="sendml" $selected{sendml}>Mailing List</option>
<option value="systools" $selected{systools}>System tools</option>
<option value="help" $selected{help}>Help</option>
~;
}
sub closedb
{
$sth="";
$dbh="";
}
