#!/usr/bin/perl
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

$ip=$ENV{REMOTE_ADDR};
open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){read (STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.="##$value";}
		else{$data{$field}=$value;}
	}
}

$destination=$data{method};
$destination="genset" unless ($destination);
$selected{$destination}="selected";

$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,acctype,status FROM mw_users WHERE (email='$data{email}' AND password='$data{password}')");
($uid,$type,$status)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($uid)
{
	$sth=$dbh->query("LOCK TABLES mw_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE mw_users SET lastuip='$ip' WHERE email='$data{email}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&closedb;
	open (F,"<$mwpath/template/errauth.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&notaccepted if ($status==0);
&disabled if ($status==2);
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT allowsend,maxsubscr,maxlist,autoaccept,allowsends,validation,limitpermonth,advert,archive,addfeat,usedomain,advertad FROM mw_acctype WHERE atid=$type");
($allowsend,$maxsubscr,$maxlist,$autoaccept,$allowsends,$validation,$limitpermonth,$advert,$archive,$addfeat,$usedomain,$advertad)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&$destination;


sub genset
{
$selected[$data{id}]="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname,mstyle,subj,header,footer FROM mw_lists WHERE uid=$uid");
while(($lid,$lname,$mstyle,$subj,$mheader,$mfooter)=$sth->fetchrow)
{
	$data{id}=$lid unless ($data{id});
	$lname=~s/APOSTROPHH/'/g;
	$lists.=qq~<option value="$lid" $selected[$lid]>$lname</option>\n~;
	if ($lid==$data{id})
	{
		$header=$mheader;
		$footer=$mfooter;
		$subject=$subj;
		$type=$mstyle;
		$ttoshow=$lname;
		$header=~s/APOSTROPHH/'/g;
		$footer=~s/APOSTROPHH/'/g;
		$subject=~s/APOSTROPHH/'/g;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sele[$type]="checked";
$addline=qq~<tr><td colspan=2><font size=2><textarea name="fbody" cols=53 rows=5>$footer</textarea></font></td></tr>~ unless ($advert);
&closedb;
&methods;
open (F,"<$mwpath/template/mgenset.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub chset
{
$data{subject}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES mw_lists WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_lists SET mstyle=$data{type},subj='$data{subject}' WHERE (uid=$uid AND lid=$data{id})");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub header
{
$data{body}=~s/'/APOSTROPHH/g;
$data{fbody}=~s/'/APOSTROPHH/g;
$data{body}=~s/\r//g;
$data{fbody}=~s/\r//g;
$sth=$dbh->query("LOCK TABLES mw_lists WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_lists SET header='$data{body}',footer='$data{fbody}' WHERE (uid=$uid AND lid=$data{id})");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub usrman
{
$selected{usrman}="selected";
$found="";
$tlist=0;
$selected[$data{id}]="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname FROM mw_lists WHERE uid=$uid");
while(($lid,$lname)=$sth->fetchrow)
{
	$tlist++;
	$data{id}=$lid unless ($data{id});
	$lname=~s/APOSTROPHH/'/g;
	$lists.=qq~<option value="$lid" $selected[$lid]>$lname</option>\n~;
	if ($lid==$data{id})
	{
		$ttoshow=$lname;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($lists)
{
$result=qq~
<tr><td width="60%" valign="top"><font size=2><select name="id">
$lists
</select></font></td><td width="40%" valign="top" align="right"><font size=2><input type="submit" name="method" value="Remove_list"><br>Here you can remove your lists</font></td></tr>
~;
$preres=qq~
<tr><td width="60%" valign="top"><font size=2><select name="id">
$lists
</select></font></td><td width="40%" valign="top" align="right"><font size=2><input type="submit" name="method" value="Choose_list"></font></td></tr>
~;
}
if ($tlist<$maxlist && $maxlist)
{
$result.=qq~
<tr><td width="60%" valign="top"><font size=2><input type="text" size=25 name="title">
</font></td><td width="40%" valign="top" align="right"><font size=2><b>New list title</b></font></td></tr>
<tr><td width="60%" valign="top"><font size=2>&nbsp;</font></td><td width="40%" valign="top" align="right"><font size=2><input type="submit" name="method" value="Add_list"><br>Here you can add new list</font></td></tr>
~;
}
if ($data{id})
{
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT sid,email FROM mw_subscr_$uid WHERE lid=$data{id}");
while(($sid,$email)=$sth->fetchrow)
{
	$addrs.=qq~<option value="$sid">$email</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($addrs)
{
$result1=qq~
<tr><td width="60%" valign="top"><font size=2><select name="user" multiple size=5>$addrs</select></font></td><td width="40%" valign="top" align="right"><font size=2><input type="submit" name="method" value="Remove_addresses"><br>Here you can remove your subscribers from list</font></td></tr>
<tr><td width="60%" valign="top"><font size=2><b>Download list</b></font></td><td width="40%" valign="top" align="right"><font size=2><input type="submit" name="method" value="Download"></font></td></tr>
~;
}
if ($addfeat && $data{id})
{
$result1.=qq~
<tr><td width="60%" valign="top"><font size=2><textarea rows=5 cols=30 name="adduser"></textarea>
</font></td><td width="40%" valign="top" align="right"><font size=2><input type="submit" name="method" value="Add_addresses"><br>Here you can add email addresses manually. Addresses must be carriage return separated</font></td></tr>
~;
}
&methods;
&closedb;
open (F,"<$mwpath/template/musrman.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub Choose_list
{
&usrman;
}
sub Remove_list
{
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid WRITE, mw_history_$uid WRITE, mw_lists WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM mw_subscr_$uid WHERE lid=$data{id}");
$sth=$dbh->query("DELETE FROM mw_history_$uid WHERE lid=$data{id}");
$sth=$dbh->query("DELETE FROM mw_lists WHERE (lid=$data{id} AND uid=$uid)");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$data{id}="";
&usrman;
}
sub Add_list
{
if ($data{title})
{
	$data{title}=~s/'/APOSTROPHH/g;
	$sth=$dbh->query("LOCK TABLES mw_lists WRITE") if ($locktables);
	$sth=$dbh->query("SELECT COUNT(*) FROM mw_lists WHERE uid=$uid");
	$tlist=$sth->fetchrow;
	if ($tlist<$maxlist && $maxlist)
	{
		$sth=$dbh->query("INSERT INTO mw_lists (uid,lname,mstyle) VALUES ($uid,'$data{title}',0)");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&usrman;
}
sub Download
{
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM mw_subscr_$uid WHERE lid=$data{id}");
@list=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@list){$_.="\n";}
&closedb;
print "content-disposition: filename=\"list.txt\"; \n";
print "content-type: application/msword\n\n";
print @list;
exit;
}
sub Remove_addresses
{
@users=split("##",$data{user});
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid WRITE") if ($locktables);
foreach(@users)
{
	$sth=$dbh->query("DELETE FROM mw_subscr_$uid WHERE (lid=$data{id} AND sid=$_)");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&usrman;
}
sub Add_addresses
{
$selected{usrman}="selected";
if ($addfeat)
{
$data{adduser}=~s/\r//g;
$data{adduser}=~s/ //g;
$data{adduser}=~s/,/\n/g;
$data{adduser}=~s/;/\n/g;
@adduser=split("\n",$data{adduser});
$total=scalar(@adduser);
$suc=0;
$unsuc=0;
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid WRITE") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$uid WHERE lid=$data{id}");
$count=$sth->fetchrow;
foreach(@adduser)
{
	$count++;
	unless ($_=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $_=~/^\w+/ && $_=~/\w+$/)
	{
		$log.="$_ - <b>NOT</b> added. Reason - bad format.<br>\n";
		$unsuc++;
		next;
	}
	$sth=$dbh->query("SELECT sid FROM mw_subscr_$uid WHERE (lid=$data{id} AND email='$_')");
	$sid=$sth->fetchrow;
	if ($sid)
	{
		$log.="$_ - <b>NOT</b> added. Reason - already exist.<br>\n";
		$unsuc++;
		next;
	}
	if ($count>$maxsubscr && $maxsubscr)
	{
		$log.="$_ - <b>NOT</b> added. Reason - subscribers quota exceed.<br>\n";
		$unsuc++;
		next;
	}
	$suc++;
	$sth=$dbh->query("INSERT INTO mw_subscr_$uid (lid,email,status) VALUES ($data{id},'$_',1)");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$log="ERRORS:<br>\n$log" if ($log);
$log="Processed: $total addresses<br>Added: $suc addresses<br>Skipped: $unsuc addresses<br>\n$log";
&methods;
&closedb;
open (F,"<$mwpath/template/mlog.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
&usrman;
}
sub sendml
{
$selected[$data{id}]="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname,subj FROM mw_lists WHERE uid=$uid");
while(($lid,$lname,$subj)=$sth->fetchrow)
{
	$data{id}=$lid unless ($data{id});
	$lname=~s/APOSTROPHH/'/g;
	$lists.=qq~<option value="$lid" $selected[$lid]>$lname</option>\n~;
	if ($lid==$data{id})
	{
		$ttoshow=$lname;
		$subject=$subj;
		$subject=~s/APOSTROPHH/'/g;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($lists)
{
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">CHOOSE LIST</font>
<form action="$cgi/mwmember.pl" method="post"><input type="hidden" name="email" value="$data{email}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="sendml">
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b><select name=id>$lists</select></b></font></td><td width="60%" align="right"><font size=2><input type="submit" value="Choose" size=40></font></td></tr>
</table></form>
</td></tr>
~;
}
if ($data{id})
{
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$uid WHERE (lid=$data{id} AND status=1)");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$sth=$dbh->query("LOCK TABLES mw_history_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_history_$uid WHERE (lid=$data{id} AND statd<'$year-$month-31 23:59:59' AND statd>'$year-$month-01 00:00:00')");
$wassent=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($wassent>=$limitpermonth && $limitpermonth)
{
$result.=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">MAILING LIST</font>
<table bgcolor="#E0E0E0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td><font size="2"><b>You already sent $wassent of $limitpermonth messages this month.</b></font></td></tr>
</table></td></tr>
~;
}
else
{
if ($allowsend)
{
$limitpermonth="unlimited" unless ($limitpermonth);
$result.=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">MAILING LIST<br>LIST: $ttoshow</font>
<form method="post" action="$cgi/mwmember.pl">
<input type="hidden" name="email" value="$data{email}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="maillist"><input type="hidden" name="id" value="$data{id}">
<table bgcolor="#E0E0E0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td colspan=2><font size="2"><b>You have $total subscribers. You have sent $wassent($limitpermonth) messages this month.</b></font></td></tr>
<tr><td width="20%"><font size="2"><b>Subject</b></font></td>
<td width="80%"><input type="text" name="subject" size="49" value="$subject"></td></tr>
<tr><td colspan=2 align="center"><textarea name="body" cols=53 rows=5></textarea></td></tr>
<tr><td colspan=2 align="center"><input type="submit" value="Send newsletter"></td></tr>
</table></form></td></tr>
~;
}
else
{
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">MAILING LIST</font>
<table bgcolor="#E0E0E0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td><font size="2"><b>This function is disabled</b></font></td></tr>
</table></td></tr>
~;
}
}
}
&methods;
&closedb;
open (F,"<$mwpath/template/msendml.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub maillist
{
$selected{sendml}="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname,mstyle,footer,header FROM mw_lists WHERE (uid=$uid AND lid=$data{id})");
($lid,$ttoshow,$type,$footer,$header)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&sendml unless ($lid);
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$uid WHERE (lid=$data{id} AND status=1)");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$sth=$dbh->query("LOCK TABLES mw_history_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_history_$uid WHERE (lid=$data{id} AND statd<'$year-$month-31 23:59:59' AND statd>'$year-$month-01 00:00:00')");
$wassent=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($wassent>=$limitpermonth && $limitpermonth)
{
	$cantsend=1;
}
else
{
	$cantsend=0;
}
if ($advert){$footer=$advertad;}
if ($type==1)
{
	$footer=~s/\n/\<br\>/g;
	$header=~s/\n//g;
	$data{body}=~s/\r\n//g;
	$data{body}=~s/'/APOSTROPHH/g;
}
else
{
	$data{body}=~s/\r//g;
	$data{body}=~s/'/APOSTROPHH/g;
}
$data{subject}=~s/'/APOSTROPHH/g;
if ($allowsend && !$cantsend)
{
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$sth=$dbh->query("LOCK TABLES mw_history_$uid WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO mw_history_$uid (lid,statd,subject,message) VALUES ($data{id},'$year-$month-$date $time','$data{subject}','$header\n$data{body}\n\n$footer')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$hid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$addres=qq~<script type="text/javascript" language="Javascript">
window.open("$cgi/nph-mwmmail.pl?method=maillist&name=$data{email}&password=$data{password}&id=$data{id}&hid=$hid", 'f', 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=113,height=135');
</script>
~;
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">SENDMAIL STATUS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td><font size=2>Sending newsletter to $total users (List: $ttoshow)</font></td></tr>
</table></form>
</td></tr>
~;
}
else
{
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">SENDMAIL STATUS</font>
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td><font size="2"><b>This function is disabled</b></font></td></tr>
</table></td></tr>
~;
}
&methods;
&closedb;
open (F,"<$mwpath/template/mmaillist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remove
{
&methods;
&closedb;
open (F,"<$mwpath/template/mremove.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remove_confirm
{
$sth=$dbh->query("LOCK TABLES mw_lists WRITE, mw_alist WRITE, mw_users WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM mw_lists WHERE uid=$uid");
$sth=$dbh->query("DELETE FROM mw_users WHERE uid=$uid");
$sth=$dbh->query("DELETE FROM mw_alist WHERE email='$data{email}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("DROP TABLE mw_history_$uid");
$sth=$dbh->query("DROP TABLE mw_subscr_$uid");
&methods;
&closedb;
open (F,"<$mwpath/template/mcremove.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub getcode
{
$selected[$data{id}]="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname FROM mw_lists WHERE uid=$uid");
while(($lid,$lname)=$sth->fetchrow)
{
	$data{id}=$lid unless ($data{id});
	$lname=~s/APOSTROPHH/'/g;
	$lists.=qq~<option value="$lid" $selected[$lid]>$lname</option>\n~;
	if ($lid==$data{id})
	{
		$ttoshow=$lname;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($lists)
{
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">CHOOSE LIST</font>
<form action="$cgi/mwmember.pl" method="post"><input type="hidden" name="email" value="$data{email}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="getcode">
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b><select name=id>$lists</select></b></font></td><td width="60%" align="right"><font size=2><input type="submit" value="Choose" size=40></font></td></tr>
</table></form>
</td></tr>
~;
}
if ($allowsends)
{
$result1=qq~
<tr><td width="100%">
<form name=code1>
<table bgcolor="#E0E0E0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td><font size="2"><b>Place this code to your page if you wish your subscribers to send messages to maillist</b></font></td></tr>
<tr><td colspan=2 align="center">
<textarea cols=50 rows=5>
<!--Begin $owntitle code-->
<form action="$cgi/mwmsubs.pl" method="post"><input type="hidden" name="lid" value="$data{id}"><input type="hidden" name="uid" value="$uid">Your email: <input type="text" size="30" name="email"><input type="submit" value="Login"></form>
<!--End $owntitle code-->
</textarea>
</td></tr>
</table></form></td></tr>
~;
}
&closedb;
&methods;
open (F,"<$mwpath/template/mhtml.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub help
{
if ($validation)
{
$addition=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">VALIDATION HELP</font><br>
<font size=2>
Here you can get not validated email addresses (addresses of persons who didnt confirm subscription by clicking on link sent to them by email) for each of your maillists. Also you can clear these databases.
</font></td></tr>
~;
}
if ($allowsends){$addition2="Also you can get HTML code to allow your subscribers to send mail to maillist.";}
&methods;
open (F,"<$mwpath/template/mhelp.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub notaccepted
{
&closedb;
open (F,"<$mwpath/template/errauth1.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub disabled
{
&closedb;
open (F,"<$mwpath/template/errauth2.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub valid
{
$selected[$data{id}]="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname,mstyle,subj,header,footer FROM mw_lists WHERE uid=$uid");
while(($lid,$lname)=$sth->fetchrow)
{
	$data{id}=$lid unless ($data{id});
	$lname=~s/APOSTROPHH/'/g;
	$lists.=qq~<option value="$lid" $selected[$lid]>$lname</option>\n~;
	if ($lid==$data{id})
	{
		$ttoshow=$lname;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($data{id})
{
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM mw_subscr_$uid WHERE (lid=$data{id} AND status IS NULL)");
@dta=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$dta=join("<br>",@dta);
if ($lists)
{
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">CHOOSE LIST</font>
<form action="$cgi/mwmember.pl" method="post"><input type="hidden" name="email" value="$data{email}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="valid">
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b><select name=id>$lists</select></b></font></td><td width="60%" align="right"><font size=2><input type="submit" value="Choose" size=40></font></td></tr>
</table></form>
</td></tr>
~;
}
&methods;
&closedb;
open (F,"<$mwpath/template/mvalid.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_valid
{
$selected{valid}="selected";
$sth=$dbh->query("LOCK TABLES mw_subscr_$uid WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM mw_subscr_$uid WHERE (lid=$data{id} and status IS NULL)");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&valid;
}
sub messhist
{
$selected{messhist}="selected";
$selected[$data{id}]="selected";
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname,mstyle,subj,header,footer FROM mw_lists WHERE uid=$uid");
while(($lid,$lname,$mstyle,$subj,$mheader,$mfooter)=$sth->fetchrow)
{
	$data{id}=$lid unless ($data{id});
	$lname=~s/APOSTROPHH/'/g;
	$lists.=qq~<option value="$lid" $selected[$lid]>$lname</option>\n~;
	if ($lid==$data{id})
	{
		$ttoshow=$lname;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($lists)
{
$resultl=qq~
<tr><td width="60%" valign="top"><font size=2><select name="id">
$lists
</select></font></td><td width="40%" valign="top" align="right"><font size=2><input type="submit" value="Choose"></font></td></tr>
~;
}
$start=$data{start};
@data=();
if ($data{id})
{
$sth=$dbh->query("LOCK TABLES mw_history_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT hid,statd,subject FROM mw_history_$uid WHERE lid=$data{id} ORDER BY statd DESC");
while (($hid,$statd,$subject)=$sth->fetchrow)
{
	$subject=~s/APOSTROPHH/'/g;
	push(@data,"$hid\t$subject\t$statd");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>20)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwmember.pl?email=$data{email}&password=$data{password}&method=$data{method}&start=$pstart&id=$data{id}\">PREV</a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=1><b>$icount MESSAGES IN ARCHIVE</b></font></td>");
	if ($start*20+20<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/mwmember.pl?email=$data{email}&password=$data{password}&method=$data{method}&start=$nstart&id=$data{id}\">NEXT</a></td>");
	}
		else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=1><b>$icount MESSAGES IN ARCHIVE</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*20+20>scalar(@data))
{
	$i=$start*20;
	while($i<scalar(@data))
	{
		($hid,$subject,$statd)=split("\t",$data[$i]);
		push(@result,"<tr><td><font size=2>$statd</font></td><td><font size=2><a href=\"$cgi/mwmember.pl?email=$data{email}&password=$data{password}&method=readmessage&hid=$hid\">$subject</a></td></tr>\n");
		$i++;
	}
}
else
{
	$i=$start*20;
	$last=$i+20;
	while($i<$last)
	{
		($hid,$subject,$statd)=split("\t",$data[$i]);
		push(@result,"<tr><td><font size=2>$statd</font><td><td><font size=2><a href=\"$cgi/mwmember.pl?email=$data{email}&password=$data{password}&method=readmessage&hid=$hid\">$subject</a></td></tr>\n");
		$i++;
	}
}
}
if (!@result)
{
	push(@result,"<tr><td colspan=2 align=center><font size=2>No messages in archive</font></td></tr>");
}
&methods;
&closedb;
open (F,"<$mwpath/template/mmesshist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub readmessage
{
$selected{messhist}="selected";
$sth=$dbh->query("LOCK TABLES mw_history_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT subject,message FROM mw_history_$uid WHERE hid=$data{hid}");
($subject,$message)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$subject=~s/APOSTROPHH/'/g;
$message=~s/APOSTROPHH/'/g;
$message=~s/\n/\<br\>\n/g;
&methods;
&closedb;
open (F,"<$mwpath/template/mmessage.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub methods
{
$addoptions=qq~<option value="sendml" $selected{sendml}>Send Mail</option>\n~ if ($allowsend);
$addoptions.=qq~<option value="valid" $selected{valid}>Validation</option>\n~ if ($validation);
$addoptions.=qq~<option value="messhist" $selected{messhist}>Messages Archive</option>\n~ if ($archive);
$methods=qq~
<option value="genset" $selected{genset}>General Settings</option>
<option value="usrman" $selected{usrman}>Lists Management</option>
$addoptions
<option value="getcode" $selected{getcode}>Get HTML Code</option>
<option value="help" $selected{help}>Online help</option>
<option value="remove" $selected{remove}>Cancel Account</option>
~;
}
sub closedb
{
$sth="";
$dbh="";
}
