#!/usr/bin/perl
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){read (STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.="##$value";}
		else{$data{$field}=$value;}
	}
}
$destination=$data{method};
$destination="initial" unless ($destination);

if (!$data{uid} || !$data{lid} || $data{uid}=~/\D+/ || $data{lid}=~/\D+/)
{
	&closedb;
	open (F,"<$mwpath/template/errauth4.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES mw_subscr_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT sid FROM mw_subscr_$data{uid} WHERE (lid=$data{lid} AND email='$data{email}')");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($sid)
{
	&closedb;
	open (F,"<$mwpath/template/errauth3.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT acctype FROM mw_users WHERE uid=$data{uid}");
$acctype=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT subj FROM mw_lists WHERE (uid=$data{uid} AND lid=$data{lid})");
$subject=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT allowsend,maxsubscr,maxlist,autoaccept,allowsends,validation,limitpermonth,advert,archive,addfeat,usedomain,advertad FROM mw_acctype WHERE atid=$acctype");
($allowsend,$maxsubscr,$maxlist,$autoaccept,$allowsends,$validation,$limitpermonth,$advert,$archive,$addfeat,$usedomain,$advertad)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&$destination;

sub initial
{
$sth=$dbh->query("LOCK TABLES mw_subscr_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$data{uid} WHERE (lid=$data{lid} AND status=1)");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$sth=$dbh->query("LOCK TABLES mw_history_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_history_$data{uid} WHERE (lid=$data{lid} AND statd<'$year-$month-31 23:59:59' AND statd>'$year-$month-01 00:00:00')");
$wassent=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($wassent>=$limitpermonth && $limitpermonth)
{
$result.=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">MAILING LIST</font>
<table bgcolor="#E0E0E0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td><font size="2"><b>Already sent $wassent of $limitpermonth messages this month.</b></font></td></tr>
</table></td></tr>
~;
}
else
{
if ($allowsend)
{
$limitpermonth="unlimited" unless ($limitpermonth);
$result.=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">MAILING LIST</font>
<form method="post" action="$cgi/mwmsubs.pl">
<input type="hidden" name="email" value="$data{email}"><input type="hidden" name="method" value="maillist"><input type="hidden" name="lid" value="$data{lid}"><input type="hidden" name="uid" value="$data{uid}">
<table bgcolor="#E0E0E0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td colspan=2><font size="2"><b>There are $total subscribers. Sent $wassent($limitpermonth) messages this month.</b></font></td></tr>
<tr><td width="20%"><font size="2"><b>Subject</b></font></td>
<td width="80%"><input type="text" name="subject" size="49" value="$subject"></td></tr>
<tr><td colspan=2 align="center"><textarea name="body" cols=53 rows=5></textarea></td></tr>
<tr><td colspan=2 align="center"><input type="submit" value="Send newsletter"></td></tr>
</table></form></td></tr>
~;
}
else
{
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">MAILING LIST</font>
<table bgcolor="#E0E0E0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td><font size="2"><b>This function is disabled</b></font></td></tr>
</table></td></tr>
~;
}
}
&closedb;
open (F,"<$mwpath/template/subs.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub maillist
{
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,lname,mstyle,footer,header FROM mw_lists WHERE (uid=$data{uid} AND lid=$data{lid})");
($lid,$ttoshow,$type,$footer,$header)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&sendml unless ($lid);
$sth=$dbh->query("LOCK TABLES mw_subscr_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_subscr_$data{uid} WHERE (lid=$data{lid} AND status=1)");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$sth=$dbh->query("LOCK TABLES mw_history_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(*) FROM mw_history_$data{uid} WHERE (lid=$data{lid} AND statd<'$year-$month-31 23:59:59' AND statd>'$year-$month-01 00:00:00')");
$wassent=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($wassent>=$limitpermonth && $limitpermonth)
{
	$cantsend=1;
}
else
{
	$cantsend=0;
}
if ($advert){$footer=$advertad;}
if ($type==1)
{
	$footer=~s/\n/\<br\>/g;
	$header=~s/\n//g;
	$data{body}=~s/\r\n//g;
	$data{body}=~s/'/APOSTROPHH/g;
}
else
{
	$data{body}=~s/\r//g;
	$data{body}=~s/'/APOSTROPHH/g;
}
$data{subject}=~s/'/APOSTROPHH/g;
if ($allowsend && !$cantsend)
{
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$sth=$dbh->query("LOCK TABLES mw_history_$data{uid} WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO mw_history_$data{uid} (lid,statd,subject,message) VALUES ($data{lid},'$year-$month-$date $time','$data{subject}','$header\n$data{body}\n\n$footer')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$hid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$addres=qq~<script type="text/javascript" language="Javascript">
window.open("$cgi/nph-mwsmail.pl?method=maillist&name=$data{email}&lid=$data{lid}&uid=$data{uid}&hid=$hid", 'f', 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=113,height=135');
</script>
~;
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">SENDMAIL STATUS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td><font size=2>Sending newsletter to $total users (List: $ttoshow)</font></td></tr>
</table></form>
</td></tr>
~;
}
else
{
$result=qq~
<tr><td width="100%">
<font size=5 color="#00B0B0">SENDMAIL STATUS</font>
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td><font size="2"><b>This function is disabled</b></font></td></tr>
</table></td></tr>
~;
}
&closedb;
open (F,"<$mwpath/template/subs.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
