#!/usr/bin/perl
use Socket;
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){read (STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.="##$value";}
		else{$data{$field}=$value;}
	}
}

$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT password FROM mw_users WHERE email='$data{email}'");
$password=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($password)
{
	$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT uheader,ufooter FROM mw_settings");
	($ruheader,$rufooter)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$ruheader=~s/APOSTROPHH/'/g;
	$rufooter=~s/APOSTROPHH/'/g;
	if ($smtpserver)
	{
		$header=$ruheader;
		$bottom=$rufooter;
		&sendviasmtp("$email ($owntitle)",$data{email},"Welcome to MailWorld","$header\nCongratulations! Your account has been registered successfully. Please login to members section to get HTML code and manage your account:\n\n$mailworld/members.html and use\nLogin: $data{email}\nPassword: $password\n\n$bottom");
	}
	else
	{
	open (MAIL,"|$progmail");
	print MAIL "To: $data{email}\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Welcome to MailWorld\n\n";
	print MAIL $ruheader;
	print MAIL "Congratulations! Your account has been registered successfully. Please login to members section to get HTML code and manage your account:\n\n";
	print MAIL "$mailworld/members.html and use\nLogin: $data{email}\nPassword: $password\n\n";
	print MAIL $rufooter;
	print MAIL "\n.\n";
	close (MAIL);
	}
	$mess="Your password has been sent to your email box. Please, check it out";
}
else
{
	$mess="Unknown account. Please, back and put in correct email address.";
}
&closedb;
open (F,"<$mwpath/template/pass.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
sub sendviasmtp
{
($from,$to,$subject,$message)=@_;
$message=~s/\n/\r\n/g;
$localhost=(gethostbyname('localhost'))[0] || 'localhost';
socket(S,PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]) || return;
$farg=sockaddr_in($smtpport,inet_aton($smtpserver)) || return;
connect(S,$farg) || return("err$!");
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="HELO $localhost\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="mail from: <$email>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="rcpt to: <$to>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="data\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
$mes="From:$from\r\nTo:$to\r\nSubject:$subject\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$mes="\r\n$message\r\n.\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="quit\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
close(S);
}
sub closedb
{
$sth="";
$dbh="";
}
