#!/usr/bin/perl
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

$query=$ENV{QUERY_STRING};
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
if ($data{destination})
{
	&closedb;
	push (@errors,"Wrong parameters, possible error in validation URL<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if (!$data{uid} || !$data{lid} || $data{uid}=~/\D+/ || $data{lid}=~/\D+/)
{
	&closedb;
	push (@errors,"Wrong parameters, possible error in validation URL<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
unless ($data{email}=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $data{email}=~/^\w+/ && $data{email}=~/\w+$/)
{
	&closedb;
	push (@errors,"Incorrect <b>e-mail</b>, you must put your e-mail address<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES mw_subscr_$data{uid} WRITE") if ($locktables);
$sth=$dbh->query("UPDATE mw_subscr_$data{uid} SET status=1 WHERE (lid=$data{lid} AND email='$data{email}')");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$mwpath/template/subscr.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
sub closedb
{
$sth="";
$dbh="";
}
