CREATE TABLE mw_users (
uid             MEDIUMINT(6) UNSIGNED NOT NULL auto_increment,
email           VARCHAR(255) NOT NULL,
password        VARCHAR(8) NOT NULL,
name            VARCHAR(150) NOT NULL,
acctype         MEDIUMINT(3) NOT NULL,
status          TINYINT(1),
lastdate        DATETIME,
lastsip         VARCHAR(15),
lastuip         VARCHAR(15),
                PRIMARY KEY (uid),
                INDEX (uid,email,acctype,status)
);
CREATE TABLE mw_acctype (
atid            MEDIUMINT(3) UNSIGNED NOT NULL auto_increment,
atname          VARCHAR(30) NOT NULL,
allowsend       TINYINT(1),
maxsubscr       MEDIUMINT(6),
maxlist         MEDIUMINT(3),
autoaccept      TINYINT(1),
allowsends      TINYINT(1),
validation      TINYINT(1),
limitpermonth   MEDIUMINT(3),
advert          TINYINT(1),
archive         TINYINT(1),
addfeat         TINYINT(1),
usedomain       TINYINT(1),
advertad        TEXT,
                PRIMARY KEY (atid),
                INDEX (atid)
);
CREATE TABLE mw_lists (
lid             MEDIUMINT(8) UNSIGNED NOT NULL auto_increment,
uid             MEDIUMINT(6) UNSIGNED NOT NULL,
lname           VARCHAR(100),
subj            VARCHAR(255),
mstyle          TINYINT(1),
header          TEXT,
footer          TEXT,
                PRIMARY KEY (lid),
                INDEX (lid,uid)
);
CREATE TABLE mw_settings (
subj            VARCHAR(255),
mstyle          TINYINT(1),
header          TEXT,
footer          TEXT,
aheader         TEXT,
afooter         TEXT,
uheader         TEXT,
ufooter         TEXT
);
CREATE TABLE mw_alist (
sid             MEDIUMINT(8) UNSIGNED NOT NULL auto_increment,
email           VARCHAR(255),
                PRIMARY KEY (sid),
                INDEX (email)
);
CREATE TABLE mw_ahistory (
hid             BIGINT(11) UNSIGNED NOT NULL auto_increment,
statd           DATETIME NOT NULL,
subject         VARCHAR(255),
message         TEXT,
                PRIMARY KEY (hid),
                INDEX (statd)
);
INSERT INTO mw_settings VALUES ('MailWorld',0,'MailWorld.

__________________________________________
',
'__________________________________________

Powered by MailWorld
Copyright 1999-2002 TRXX Programming Group
http://www.trxx.co.uk
trxx@trxx.co.uk
',
'MailWorld. New user information.

__________________________________________
',
'__________________________________________

Powered by MailWorld
Copyright 1999-2002 TRXX Programming Group
http://www.trxx.co.uk
trxx@trxx.co.uk
',
'MailWorld. Thank you for joining us.

__________________________________________
',
'__________________________________________

Powered by MailWorld
Copyright 1999-2002 TRXX Programming Group
http://www.trxx.co.uk
trxx@trxx.co.uk
');
INSERT INTO mw_acctype (atname,allowsend,maxsubscr,maxlist,autoaccept,allowsends,validation,limitpermonth,advert,archive,addfeat,usedomain,advertad) VALUES ('Free',1,50,5,1,0,1,2,1,0,0,1,'__________________________________________

Powered by MailWorld
Copyright 1999-2002 TRXX Programming Group
http://www.trxx.co.uk
trxx@trxx.co.uk
');

