#!/usr/bin/perl
use Socket;
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

print "HTTP/1.0 200 OK\n";
print "content-type: text/html\n\n";
if ($ENV{CONTENT_LENGTH}>0){if ($sysid eq "Windows"){read(STDIN,$data,$ENV{CONTENT_LENGTH});} else {$data=<STDIN>;}}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$encline=$data{name}.":".crypt($data{password},$data{password});
$destination=$data{method};
$admpass="$alogin:$apassword";
&$destination if ($admpass eq $encline);
&closedb;
print qq~<font size=4>ACCESS DENIED</font>
~;
sub maillist
{
	$sth=$dbh->query("LOCK TABLES mw_ahistory READ") if ($locktables);
	$sth=$dbh->query("SELECT subject,message FROM mw_ahistory WHERE hid=$data{hid}");
	($data{Subject},$body)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$body=~s/APOSTROPHH/'/g;
	$data{Subject}=~s/APOSTROPHH/'/g;
	$bodysmtp=$body;
	$bodysmtp=~s/\n/\r\n/g;
	$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT mstyle FROM mw_settings");
	($mstyle)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if ($mstyle){$data{Content}="text/html";$body=~s/\n/\<br\>\n/g;$bodysmtp=~s/\r\n/\<br\>\r\n/g;}
	else {$data{Content}="text/plain";}
	if ($data{type} eq "S")
	{
	$sth=$dbh->query("LOCK TABLES mw_alist READ") if ($locktables);
	$sth=$dbh->query("SELECT DISTINCT email FROM mw_alist");
	@emails=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
	if ($data{type} eq "M")
	{
	$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT DISTINCT email FROM mw_users");
	@emails=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
	&closedb;
	$count=0;
	$total=@emails;
	$current=0;
	unless ($bcc)
	{
		if (@emails>0)
		{
			foreach(@emails)
			{
				$count++;
				if ($smtpserver)
				{
					$to=$_;
					&sendviasmtp;
				}
				else
				{
				open (MAIL,"|$progmail");
				print MAIL "To: $_\n";
				print MAIL "From: $email ($owntitle)\n";
				print MAIL "Subject: $data{Subject}\n";
				print MAIL "Content-type: $data{Content}\n\n";
				print MAIL $body;
				print MAIL "\n.\n";
				close (MAIL);
				}
				if (int($count/$total*100)>$current)
				{
					$differ=int($count/$total*100)-$current;
					$current+=$differ;
					$stb=qq~<img src="$mailworld/images/mailbar.gif" height=$differ width=96><br>\n~;
					$numb=4052-7-length($stb);
					$addln="A" x $numb;
					print qq~<!--$addln-->$stb~;
				}
			}
		}
		print qq~<font size=3>MAIL SENT</font>~;
		exit;
	}
	else
	{
		if (@emails>0)
		{
			while($count<scalar(@emails))
			{
				@bcc=();
				if ($count+$bcc>scalar(@emails))
				{
					@bcc=@emails[$count..scalar(@emails)-1];
				}
				else
				{
					@bcc=@emails[$count..$count+$bcc-1];
				}
				$count+=scalar(@bcc);
				if ($smtpserver)
				{
					&sendviasmtp;
				}
				else
				{
				$to=shift(@bcc);
				$bulk=join(";",@bcc);
				open (MAIL,"|$progmail");
				print MAIL "To: $to\n";
				print MAIL "Bcc: $bulk\n";
				print MAIL "From: $email ($owntitle)\n";
				print MAIL "Subject: $data{Subject}\n";
				print MAIL "Content-type: $data{Content}\n\n";
				print MAIL $body;
				print MAIL "\n.\n";
				close (MAIL);
				}
				if (int($count/$total*100)>$current)
				{
					$differ=int($count/$total*100)-$current;
					$current+=$differ;
					$stb=qq~<img src="$mailworld/images/mailbar.gif" height=$differ width=96><br>\n~;
					$numb=4052-7-length($stb);
					$addln="A" x $numb;
					print qq~<!--$addln-->$stb~;
				}
			}
		}
		print qq~<font size=3>MAIL SENT</font>~;
		exit;
	}
}
sub sendviasmtp
{
$localhost=(gethostbyname('localhost'))[0] || 'localhost';
socket(S,PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]) || &error($!);
$farg=sockaddr_in($smtpport,inet_aton($smtpserver)) || &error($!);
connect(S,$farg) || &error($!);
$res=<S>;
if ($res=~/^[45]/){&error($res);}
$mes="HELO $localhost\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){&error($res);}
$mes="mail from: <$email>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){&error($res);}
if ($bcc)
{
foreach(@bcc)
{
$mes="rcpt to: <$_>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){push(@errorz,$res);}
}
}
else
{
$mes="rcpt to: <$to>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);push(@errorz,$res);return;}
}
$mes="data\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
$mes="From: $email ($owntitle)\r\nTo: Subscribers\r\nSubject: $data{Subject}\r\nContent-type: $data{Content}\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$mes="\r\n$bodysmtp\r\n.\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){&error($res);}
$mes="quit\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
close(S);
}
sub error
{
print $_[0];
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
